Mapstraction Javascript Library
===============================

This is now the official Mapstraction repository. It can be found at http://github.com/mapstraction/mxn

About Mapstraction
------------------

Mapstraction is a library that provides a common API for various javascript mapping APIs to enable switching from one to another as smoothly as possible. Developers can code their applications once, and then easily switch mapping provider based on project needs, terms and conditions, and new functionality.

Users can switch maps as desired based on personal taste and quality of maps in their local area. Various tools built on top of Mapstraction allow users to easily integrate maps into their own sites, and configure them with different controls, styles, and provider.

Which Mapstraction Version?
---------------------------

The last official and stable release of Mapstraction was v2.0.18 in 2011. Since then Mapstraction languished for a while but it's now under active development.

A lot has changed in the world of maps APIs since v2.0.18. Some APIs have gone to the deadpool (farewell Yahoo! Maps) and some have changed substantially (hello Google v3 and Leaflet).

If you want to live life on the bleeding edge you can try the [v3.0 branch](https://github.com/mapstraction/mxn/tree/release-3.0) but be warned, this branch is far from stable, is likely to continue to change as the official release of v3.0 draws ever nearer and also contains API changes which will break code that assumes Mapstraction v2.x. It's also not documented much, if at all.

A safer bet is to use the [v2.1 branch](https://github.com/mapstraction/mxn/tree/release-2.1). Whilst not a formally released branch, this is relatively up to date and was destined to be the next release of Mapstraction before it became evident that the project would receive a major version number boost.

In the meantime, v3.0 of Mapstraction continues onwards, [join us](https://github.com/mapstraction/mxn/wiki) and help us get Mapstraction v3.0 [out of the door](https://github.com/mapstraction/mxn/wiki/Contributing).

Why Mapstraction?
-----------------

Mapstraction additionally fills some holes each provider's current offerings (taking advantage of existing open source solutions where possible) to normalise the feature set across platforms. Mapstraction also uses OpenStreetMap for people who want to build maps without restrictions on derived works.

Mapstraction is open-source and released under the BSD License.

Major Features
--------------

* Support for more than 11 major mapping providers
* Dynamic switching of provider
* Point, Line, Polygon support
* Marker Filtering by Time, Category, or any attribute
* Image overlay and base tiles
* GeoRSS and KML feed import
* Geocoding of addresses
* Driving directions

Supported Libraries
-------------------

* [Cartociudad](http://www.cartociudad.es/VisualizadorCartografico/)
* [Cloudmade](http://developers.cloudmade.com/projects)
* [GeoCommons](http://developer.geoiq.com/api/)
* [Google Maps & Google Earth](http://code.google.com/apis/maps/index.html)
* [Leaflet](http://leaflet.cloudmade.com/)
* [MapQuest](http://developer.mapquest.com/)
* [Microsoft](http://www.microsoft.com/maps/developers/web.aspx)
* [OpenLayers](http://openlayers.org)
* OpenSpace
* [Ovi](http://api.maps.ovi.com/)
* [Yahoo](http://developer.yahoo.com/maps/)
* [Yandex](http://api.yandex.ru/)

Mapstraction Users
------------------

* Nestoria
* GeoPress
* Reuters
* The Los Angeles Times
* GeoNames
* IDELab
* ... and more


The Mapstraction homepage is available at http://mapstraction.com.
